CodeForces 816B Karen and Coffee(前缀和,大量查询)

CodeForces 816B Karen and Coffee(前缀和,大量查询)

Description

        Karen, a coffee aficionado, wants to know the optimal temperature for brewing the perfect cup of coffee. Indeed, she has spent some time reading several recipe books, including the universally acclaimed "The Art of the Covfefe".

        She knows n coffee recipes. The i-th recipe suggests that coffee should be brewed between li and ri degrees, inclusive, to achieve the optimal taste.

        Karen thinks that a temperature is admissible if at least k recipes recommend it.

        Karen has a rather fickle mind, and so she asks q questions. In each question, given that she only wants to prepare coffee with a temperature between a and b, inclusive, can you tell her how many admissible integer temperatures fall within the range?

Input

        The first line of input contains three integers, nk (1 ≤ k ≤ n ≤ 200000), and q (1 ≤ q ≤ 200000), the number of recipes, the minimum number of recipes a certain temperature must be recommended by to be admissible, and the number of questions Karen has, respectively.

        The next n lines describe the recipes. Specifically, the i-th line among these contains two integers li and ri (1 ≤ li ≤ ri ≤ 200000), describing that the i-th recipe suggests that the coffee be brewed between li and ri degrees, inclusive.

        The next q lines describe the questions. Each of these lines contains a and b, (1 ≤ a ≤ b ≤ 200000), describing that she wants to know the number of admissible integer temperatures between a and b degrees, inclusive.

Output

        For each question, output a single integer on a line by itself, the number of admissible integer temperatures between a and b degrees, inclusive.

Sample

input
3 2 4
91 94
92 97
97 99
92 94
93 97
95 96
90 100
output
3
3
0
4


input
2 1 1
1 1
200000 200000
90 100
output
0

题意: 

        给出n个区间,q个查询区间,问每次查询时,该查询区间内有多少个点至少被k个区间覆盖。

        样例1:第一行三个整数的意义是:3个区间 至少被2个区间覆盖  查询四次,第二三四行分别是三个区间。剩下四行为查询的区间,比如92 94就是在92到94中(包含92和94),多少个数被上面区间覆盖了2次(即k次)或者2次以上。在92到94的区间内92 93 94都被覆盖两次,故三个,输出3。

思路:

        数据量是2*10^5,暴力的方法肯定会超时。

        准备两个一维数组,cnt[] 和 sum[] 来处理每一个满足数 i (范围 [1, 200000]  )

        cnt[i] 数组:第 i 个数被区间包含的次数

        sum[i] 数组: 前 i 个数被 k 个包含的前缀和。

        第一组样例就是

        所以对于 k 个提问,sum[b] - sum[a-1] 就是答案了(因为sum[b]是0到b中符合条件的总数,sum[a-1](包含两个端点)是0到a中符合条件的总数,两者相减就是a到b中符合条件的总数)。

        这里最巧妙之处就是cnt[i] 要怎么统计出来。如果 [li, ri] 范围的数都遍历一次,绝对会超时, 处理两个点其实就可以统计出来了,分别是 cnt[li], cnt[ri+1]。 对于每一次询问,进行:cnt[li]++, cnt[ri+1]-- 处理。然后 q 个问题之后,再统一遍历多一次,利用前一个数 cnt[i-1] 就能统计出当前数 cnt[i] 了。

代码:

#include<stdio.h>
#include<iostream>
using namespace std;
int a[200010];
int c[200010];
int main()
{
    int k,n,q;
    int b,e;
    cin>>k>>n>>q;
    for(int i=0; i<k; i++)//输入查询
    {
        cin>>b>>e;
        a[b]++;
        a[e+1]--;
    }
    for(int i=1; i<200010; i++)//更新cnt数组
    {
        a[i]+=a[i-1];
        if(a[i]>=n)
            c[i]++;
    }
    for(int i=1; i<200010; ++i)//更新sum数组
        c[i]+=c[i-1];
    for(int i=0; i<q; i++)//输出结果
    {
        int l,r;
        scanf("%d%d",&l,&r);
        cout<<c[r]-c[l-1]<<endl;
    }
}

  

原文地址:https://www.cnblogs.com/aiguona/p/7183195.html